Loading...
Searching...
No Matches
Dune::Amg::AggregationLevelTransferPolicyCpr< O, C > Class Template Reference

A LeveTransferPolicy that used aggregation to construct the coarse level system. More...

`#include <twolevelmethodcpr.hh>`

Inheritance diagram for Dune::Amg::AggregationLevelTransferPolicyCpr< O, C >:

## Public Types

typedef LevelTransferPolicyCpr< O, O > | FatherType
typedef C | Criterion
typedef SequentialInformation | ParallelInformation
Public Types inherited from Dune::Amg::LevelTransferPolicyCpr< O, O >
typedef O | FineOperatorType
| The linear operator of the finel level system.
typedef FineOperatorType::range_type | FineRangeType
| The type of the range of the fine level operator.
typedef FineOperatorType::domain_type | FineDomainType
| The type of the domain of the fine level operator.
typedef O | CoarseOperatorType
| The linear operator of the finel level system.
typedef CoarseOperatorType::range_type | CoarseRangeType
| The type of the range of the coarse level operator.
typedef CoarseOperatorType::domain_type | CoarseDomainType
| The type of the domain of the coarse level operator.

## Public Member Functions

| AggregationLevelTransferPolicyCpr (const Criterion &crit)
void | createCoarseLevelSystem (const O &fineOperator)
| Algebraically creates the coarse level system.
void | moveToCoarseLevel (const typename FatherType::FineRangeType &fineRhs)
void | moveToFineLevel (typename FatherType::FineDomainType &fineLhs)
| Updates the fine level linear system after the correction of the coarse levels system.
AggregationLevelTransferPolicyCpr * | clone () const
| Clone the current object.
Public Member Functions inherited from Dune::Amg::LevelTransferPolicyCpr< O, O >
std::shared_ptr< CoarseOperatorType > & | getCoarseLevelOperator ()
| Get the coarse level operator.
CoarseRangeType & | getCoarseLevelRhs ()
| Get the coarse level right hand side.
CoarseDomainType & | getCoarseLevelLhs ()
| Get the coarse level left hand side.
virtual void | moveToCoarseLevel (const FineRangeType &fineRhs)=0
| Transfers the data to the coarse level.
virtual void | calculateCoarseEntries (const FineOperatorType &fineOperator)=0
| ?
virtual | ~LevelTransferPolicyCpr ()
| Destructor.

## Additional Inherited Members

Protected Attributes inherited from Dune::Amg::LevelTransferPolicyCpr< O, O >
CoarseRangeType | rhs_
| The coarse level rhs.
CoarseDomainType | lhs_
| The coarse level lhs.
std::shared_ptr< CoarseOperatorType > | operator_
| the coarse level linear operator.

## Detailed Description

template<class O, class C>
class Dune::Amg::AggregationLevelTransferPolicyCpr< O, C >

A LeveTransferPolicy that used aggregation to construct the coarse level system.

Template Parameters

  O | The type of the fine and coarse level operator.
  C | The criterion that describes the aggregation procedure.

## Member Function Documentation

## clone()

template<class O, class C>

AggregationLevelTransferPolicyCpr * Dune::Amg::AggregationLevelTransferPolicyCpr< O, C >::clone | ( |  | ) | const

inline virtual

Clone the current object.

Implements Dune::Amg::LevelTransferPolicyCpr< O, O >.

## createCoarseLevelSystem()

template<class O, class C>

void Dune::Amg::AggregationLevelTransferPolicyCpr< O, C >::createCoarseLevelSystem | ( | const O & | fineOperator | ) |

inline virtual

Algebraically creates the coarse level system.

After returning from this function the coarse level operator can be accessed using getCoarseLevelOperator().

Parameters

  fineOperator | The operator of the fine level system.

Implements Dune::Amg::LevelTransferPolicyCpr< O, O >.

## moveToFineLevel()

template<class O, class C>

void Dune::Amg::AggregationLevelTransferPolicyCpr< O, C >::moveToFineLevel | ( | typename FatherType::FineDomainType & | fineLhs | ) |

inline virtual

Updates the fine level linear system after the correction of the coarse levels system.

After returning from this function the coarse level correction will have been added to fine level system.

Parameters

  [in,out] | fineLhs | The left hand side of the fine level to update with the coarse level correction.

Implements Dune::Amg::LevelTransferPolicyCpr< O, O >.

The documentation for this class was generated from the following file:

- opm/simulators/linalg/twolevelmethodcpr.hh